#!/bin/bash
S_NAME=tomcat6
DB_NAME=rcd
C_DIR=$(cd "$(dirname "$0")"; pwd)
RCD_BIN=/usr/rcd/bin
DB_PORT_L=5432
DB_PORT_C=5433

cd $C_DIR

#include files
. ./common.json

tmpf=/tmp/_sqlout.tmp


mode=`$RCD_BIN/fetchServerState.sh|grep -i message|awk -F'=' '{print $2}'|awk '{print $1}'`
role=`$RCD_BIN/fetchServerRole.sh|grep -i message|awk -F'=' '{print $2}'|awk '{print $1}'`
if [ "$mode" = "Cluster" -a "$role" = "0" ]; then
   port=$DB_PORT_C
else
   port=$DB_PORT_L
fi

su - postgres<<EOF
    psql -d rcd -p $port -c "select ip, product_serial from lb_server_host;" > $tmpf
EOF
RE=`cat $tmpf |grep "[0-9].[0-9].[0-9]"`
host_arr="["
index=0
while read item
do
  if [ $index -gt 0 ]; then
    host_arr=${host_arr}", "
  fi
  host_arr=${host_arr}" { "
  ip=`echo $item|awk -F"|" '{print $1}'|awk '{print $1}'`
  sn=`echo $item|awk -F"|" '{print $2}'|awk '{print $1}'`
  
  host_arr=${host_arr}"\""${ip}"\""" : "
  host_arr=${host_arr}"\""${sn}"\""" } "
  ((index++))
done<<<"${RE}"

host_arr=${host_arr}"]"
e_arr_json hostSn "${host_arr}"

