define(function(require, exports, module) {
	initUpgrade(); //登陆后，检测是否有新版本，若有就升级。
	
	var global = require("./global");
	
	function init() {
		initDom();
		initEvent();
		initGlobalEvent();
		
		function initDom() {
			$('#selfServiceRateModal').modal({
				backdrop: 'static',
				show: false
			});
			
			$("#showVersionModal .modal-body .version").text(set_page_info.localVer); // set_page_info定义在setcommon.js中
		}
		function initEvent() {			
			// 默认加载设备管理页面
//			$(".main_content").load("./deviceManage/html/deviceManage.html");
			var curElement = ".main_content", nextPageUrl = "./deviceManage/html/deviceManage.html";
			global.enterPageCallback(curElement, nextPageUrl);
			
			// 注册菜单切换事件
		    $(".func_menu").on("click", function() {
				$(".func_menu").removeClass("strong_func_menu");
				$(this).addClass("strong_func_menu");
			});		    
			$("#deviceManageMenu").click(function() {		
//				$(".main_content").load("./deviceManage/html/deviceManage.html");
				global.curClickPageId = ".main_content|#deviceManageMenu";
				var curElement = ".main_content", nextPageUrl = "./deviceManage/html/deviceManage.html";
				global.enterPageCallback(curElement, nextPageUrl);
			});			
			$("#faultDiagMenu").click(function() {
//				$(".main_content").load("./faultDiagMenu/html/faultDiagMenu.html");
				global.curClickPageId = ".main_content|#faultDiagMenu";
				var curElement = ".main_content", nextPageUrl = "./faultDiagMenu/html/faultDiagMenu.html";
				global.enterPageCallback(curElement, nextPageUrl);
			});			
			$("#logDiagMenu").click(function() {
//				$(".main_content").load("./logDiag/html/logDiag.html");
				global.curClickPageId = ".main_content|#logDiagMenu";
				var curElement = ".main_content", nextPageUrl = "./logDiag/html/logDiag.html";
				global.enterPageCallback(curElement, nextPageUrl);
			});			
			$("#oneUpgradeMenu").click(function() {
//				$(".main_content").load("./oneUpgrade/html/selectDevice.html");
				global.curClickPageId = ".main_content|#oneUpgradeMenu";
				var curElement = ".main_content", nextPageUrl = "./oneUpgrade/html/oneUpgradeMenu.html";
				global.enterPageCallback(curElement, nextPageUrl);
			});			
			$("#softCenterMenu").click(function() {
//				$(".main_content").load("./softCenter/html/softCenter.html");
				global.curClickPageId = ".main_content|#softCenterMenu";
				var curElement = ".main_content", nextPageUrl = "./softCenter/html/softCenter.html";
				global.enterPageCallback(curElement, nextPageUrl);
			});
			
//			$("#robot").click(function() {
//				var gui = window.require('nw.gui');
//				gui.Shell.openExternal("http://webchat.ruijie.com.cn/live800/chatClient/chatbox.jsp?companyID=8933&configID=17&enterurl=robot&live800_ud_invite=robot");
//			});
			
			// 账户功能示例
			$(".userAccount").click(function() {				
		    	if ($(".operate_menu").is(':visible') == false) {
		    		$(".toogle_menu").hide();
		    		$(".operate_menu").show();
		    	} else {
		    		$(".operate_menu").hide();
		    	}
		    	
		    	return false; //阻止事件冒泡
		    });			
//		    $(".operate_subMenu").click(function() {
//		    	$(".operate_menu").hide();
//		    });
		    $("body").click(function() {
		    	$(".operate_menu").hide();
		    	$(".upgrade_menu").hide();
		    });
		    
		    // 工具升级功能
		    $("#toolUpgrade").click(function() {		    	
		    	if ($(".upgrade_menu").is(':visible') == false) {
		    		$(".toogle_menu").hide();
		    		$(".upgrade_menu").show();
		    	} else {
		    		$(".upgrade_menu").hide();
		    	}
		    	
		    	return false; //阻止事件冒泡
		    });
		}
		function initGlobalEvent() {
			global.exitPageCallback.exitFun = function () {
				return true;
			}
		}
	}
	exports.init = init;
});