define(function(require, exports, module) {
	var oneUpgrade = {};

	oneUpgrade.upgradeDevInfos = [];

	oneUpgrade.multiDevConnectStatus = {}; 	   		//存储批量连接设备的名称及其对应的当前状态，init -> connecting -> connected -> upgrade -> restart -> closing -> init
	oneUpgrade.batchConnectFlag = false;  			//批量连接：标志位(批量连接时连上一台设备要要断开连接)
	oneUpgrade.connect_forcedCancelFlag = false;   	//批量连接：强制取消的标志位
	oneUpgrade.connectDevNum = 0; 			   		//批量连接：存储总的设备数
	oneUpgrade.connectDevNum_getInfo = 0;  	   		//批量连接：存储所有已获取到信息的设备数(设备从  已经尝试连接 -> 断开连接  整个过程才算获取到信息, connectDevNum_getInfo=devNum时所有设备都已尝试连接并均已断开)
	oneUpgrade.connectDevNum_disconnect = 0;     	//批量连接：存储点击强制取消时需要断开连接的设备数(调用连接接口加1, 收到disconnected减1)
	
	oneUpgrade.selectedDevice = [];

	oneUpgrade.curUpgradeTactic = undefined;		//当前升级策略(安全、快速、极速、单台)

	oneUpgrade.singleUpgradeOnce = true;			//单台升级时，用户一次点击多次单台设备进行升级，该变量为true时表示这些设备全部升级完成。下一次再点击单台升级，该变量重新置为false。
	oneUpgrade.singleUpgradeCount = 0;				//单台升级时，统计剩余多少台还未升级。singleUpgradeCount等于0表示单台升级全部完成。

	oneUpgrade.batchUpgradeDevList = [];			//存储批量升级的设备
	oneUpgrade.batchUpgradeCount = undefined; 		//统计批量升级的设备台数
	oneUpgrade.multiDevRcmndVersion = {};			//存储批量升级的设备名称及其对应的推荐版本信息
	oneUpgrade.multiDevUpgradeVersion = {};			//存储批量升级的设备名称及其所要升级的版本(包括：选择或下载)
	oneUpgrade.batchUpgradeResult = {};				//存储批量升级的设备名称及其对应的升级结果
	oneUpgrade.countSuccessUpgrade = 0;				//存储批量升级成功的设备数量
	oneUpgrade.countFailUpgrade = 0;				//存储批量升级失败的设备数量

	oneUpgrade.safeUpgradeIndex = undefined;		//安全升级：当前升级到第safeUpgradeIndex台

	oneUpgrade.fastUpgradeStep = 5;					//快速升级：用户确认完后一次升级5台 (正式发布时记得改回来@???)
	oneUpgrade.fastUpgradeIndex = oneUpgrade.fastUpgradeStep;
	oneUpgrade.fastUpgradeEnd = false;
	oneUpgrade.fastUpgradeFirstDev = true;			//快速升级：表示当前升级的是第一台设备，用于判断是否启动5台升级！

	oneUpgrade.speedUpgradeStep = 10; 				//极速升级(现在叫即刻升级)一次升级10台 (正式发布时记得改回来@???) ps:现在定时重启也用原先极速升级的变量
	oneUpgrade.speedUpgradeIndex = oneUpgrade.speedUpgradeStep - 1;
	oneUpgrade.speedUpgradeEnd = false;

	oneUpgrade.uploadId = undefined;
	oneUpgrade.upgradeStatistic = {};				//存储升级工具需要上传到云端的数据
	
	//* XXX init -> connecting -> connected -> upgrade -> restart -> closing -> init
	oneUpgrade.curStatus = 'init';
	function changeDevStatus(devName, cur, next) {
	    console.log(devName + ' [curStatus] change from ' + cur + ' to ' + next);
	    return next;
	}
	
	exports.oneUpgrade = oneUpgrade;
	exports.changeDevStatus = changeDevStatus;
});