define(function(require, exports, module) {
	var global = require("../../js/global");
	var jGlobal = require("./oneUpgradeGlobal");
	var deviceManage = require("../../deviceManage/js/deviceManage");
	
	//当前页面变量
//	var upgradeTableLength = null;
	var userClickRowArray = [];
	
	function showUpgradeDeviceTable() {
//		console.error(jGlobal.oneUpgrade.multiDevRcmndVersion);
		var selectDevInfos = [];
		for (var key in jGlobal.oneUpgrade.multiDevRcmndVersion) {
			selectDevInfos.push(global.devicesIns.getDeviceInfoByDeviceName(key));
		}
//		console.error(selectDevInfos);
		
		jGlobal.oneUpgrade.upgradeDevInfos = [];
		for (var i = 0; i < selectDevInfos.length; i++) {
			var flag = false;
			for (var j = 0; j < jGlobal.oneUpgrade.upgradeDevInfos.length; j++) {				
				var tmpRecmndVersion = jGlobal.oneUpgrade.upgradeDevInfos[j].recmndVersion;
				if (tmpRecmndVersion != null && tmpRecmndVersion != '' && tmpRecmndVersion != '-') {
					if (jGlobal.oneUpgrade.multiDevRcmndVersion[selectDevInfos[i].deviceName].softwareVersion == tmpRecmndVersion) {
						flag = true;
						jGlobal.oneUpgrade.upgradeDevInfos[j].deviceName = "-";
						jGlobal.oneUpgrade.upgradeDevInfos[j].deviceNum++;
						jGlobal.oneUpgrade.upgradeDevInfos[j].deviceNames.push(selectDevInfos[i].deviceName);
						break;
					}
				}
			}
			if (flag == false) {
				var tmp_upgradeDevInfos = {};
				tmp_upgradeDevInfos.deviceNames = [];
				tmp_upgradeDevInfos.deviceNames.push(selectDevInfos[i].deviceName);
				
				tmp_upgradeDevInfos.deviceName = selectDevInfos[i].deviceName;
				tmp_upgradeDevInfos.deviceModel = selectDevInfos[i].deviceModel;
				tmp_upgradeDevInfos.hardVer = selectDevInfos[i].hardVer;
				tmp_upgradeDevInfos.softVer = selectDevInfos[i].softVer;
				tmp_upgradeDevInfos.recmndVersion = jGlobal.oneUpgrade.multiDevRcmndVersion[selectDevInfos[i].deviceName].softwareVersion;			
				tmp_upgradeDevInfos.deviceNum = 1;
				tmp_upgradeDevInfos.recmndVersionMsg = jGlobal.oneUpgrade.multiDevRcmndVersion[selectDevInfos[i].deviceName];
				jGlobal.oneUpgrade.upgradeDevInfos.push(tmp_upgradeDevInfos);
			}
		}
//		upgradeTableLength = jGlobal.oneUpgrade.upgradeDevInfos.length;
//		console.error(jGlobal.oneUpgrade.upgradeDevInfos);
		
		$('#table_upgrade').bootstrapTable('load', jGlobal.oneUpgrade.upgradeDevInfos);
	}
	
	function recmndVersionShow(value, row, index) {
		if (row.recmndVersion == undefined) {
			return;
		}

	    if (row.recmndVersion == "下载完成" || row.recmndVersion == "文件已存在") {
	    	return '<span style="color:#0cc757;">' + row.recmndVersion + '</span>';
	    } else if (row.recmndVersion == "下载失败" || row.recmndVersion == "md5校验失败") {
	    	return '<span style="color:#f5224c;">' + row.recmndVersion + '</span>';
	    } else {
	    	return '<span>' + row.recmndVersion + '</span>';
	    }
	}
	
	function operateForUpgradeTable() {
	    return '<div>' +
	                '<div class="table-btn select" style="float: left; width: 75px;">本地导入</div>' +
	                '<div class="table-btn download" style="float: left; width: 75px; margin-left: 5px;">云端下载</div>' +
	           '</div>';
	}
	
	function importLocalVersion(row, index) {
	    var import_localVersion = $('#selectLocalVersion');
	    import_localVersion.unbind('change');
	    import_localVersion.change(function(evt) {
	    	var srcFilePath = $(this).val();
	        var srcFilePath_array = srcFilePath.split('\\');        
	        var dstFilePath = global.nwPath.resolve(global.oneUpgradeIns.getRootDir(), srcFilePath_array[srcFilePath_array.length - 1]); //选中文件后，把该文件拷贝到指定目录下
	        var params = {};
	        params.srcFilePath = srcFilePath;
	        params.srcFilePath_array = srcFilePath_array;
	        params.dstFilePath = dstFilePath;
	        params.index = index;
	        params.row = row;
	        
	        $(this).val("");

	        if (row.deviceModel != null && row.deviceModel.indexOf("S2928G-E") != -1) {
	    		if (srcFilePath_array[srcFilePath_array.length - 1].length >= 32) {
	    			alert(undefined, "S2928G-E型号设备的升级bin文件名太长，请修改为小于32个字节！");
	    			return;
	    		}
	    	}
	        
	        global.oneUpgradeIns.selectAndCopyToFtpDir(srcFilePath, dstFilePath, selectAndCopyToFtpDirCallback, params);
	    });
	    import_localVersion.trigger('click');
	}
	
	function selectAndCopyToFtpDirCallback(params) {
		/* 拷贝完成后，用户输入md5进行校验 */
		$("#selectVersionModal").modal('show');
	    
	    var srcFilePath_array = params.srcFilePath_array;
	    
	    $("#inputMd5").val("");
	    $("#chooseVersion").val(srcFilePath_array[srcFilePath_array.length - 1]);
	    
	    $("#compareVersion").click(function() {	    	
			var selectFileMd5 = global.jsUtil.countFileMd5(params.dstFilePath).toLocaleLowerCase();
			console.log(selectFileMd5);
			
	        if (selectFileMd5 == $("#inputMd5").val().toLocaleLowerCase()) {
	        	$("#table_upgrade").bootstrapTable('updateRow', {
	            	index: params.index,
	            	row: {
	            		recmndVersion: srcFilePath_array[srcFilePath_array.length - 1]
	            	}
	            });

	            for (var key in jGlobal.oneUpgrade.multiDevUpgradeVersion) {
	            	if ($.inArray(key, params.row.deviceNames) != -1) {
	        			var objectTmp = {};
	        			objectTmp.versionCode = srcFilePath_array[srcFilePath_array.length - 1];
	        			objectTmp.versionName = srcFilePath_array[srcFilePath_array.length - 1];
	        			objectTmp.fileMd5 = selectFileMd5;
	        			jGlobal.oneUpgrade.multiDevUpgradeVersion[key] = objectTmp;
	            	}
	            }
	            
	            //用户已点击了该行
				if ($.inArray(params.index, userClickRowArray) === -1) {
					userClickRowArray.push(params.index);
				}
	        } else {
	        	$("#table_upgrade").bootstrapTable('updateRow', {
	            	index: params.index,
	            	row: {
	            		recmndVersion: "md5校验失败"
	            	}
	            });
	        	
	        	for (var key in jGlobal.oneUpgrade.multiDevUpgradeVersion) {
	            	if ($.inArray(key, params.row.deviceNames) != -1) {
	            		jGlobal.oneUpgrade.multiDevUpgradeVersion[key] = "";
	            	}
	            }
	        }
	        
	        $("#compareVersion").unbind('click');
	    });
	}
	
	function downloadVersionFromCloud(row, index) {
		//用户已点击了该行
		if ($.inArray(index, userClickRowArray) === -1) {
			userClickRowArray.push(index);
		}
		
		if (row.recmndVersion == null || row.recmndVersion == '-' || row.recmndVersion == "" || row.recmndVersion == undefined) {
			alert(undefined, "云端暂无推荐规则，请根据版本管理系统进行评估。");		
			return;
		}
		if (row.softVer == row.recmndVersion) {
			alert(undefined, "已经是最新推荐版本！");
			return;
		}
		
		//判断当前版本是否已存在	
		var downloadDirPath = global.oneUpgradeIns.getRootDir();
		var downloadFileName = row.recmndVersionMsg.fileName;
		var downloadFilePath = global.nwPath.resolve(downloadDirPath, downloadFileName);
		
		if (global.fs.existsSync(downloadFilePath)) {
			$("#table_upgrade").bootstrapTable('updateRow', {
				index: index,
				row: {
					recmndVersion: "文件已存在"
				}
			});
			
			return;
		}
		
		$("#table_upgrade").bootstrapTable('updateRow', {
			index: index, 
			row: {
				recmndVersion: "正在下载…"
			}
		});
		
		for (var key in jGlobal.oneUpgrade.multiDevUpgradeVersion) {
	    	if ($.inArray(key, row.deviceNames) != -1) {
	    		jGlobal.oneUpgrade.multiDevUpgradeVersion[key] = "";
	        }
	    }
		
		var addParams = {};
		addParams.deviceNames = row.deviceNames;
		addParams.index = index;
		addParams.recmndVersionMsg = row.recmndVersionMsg;
		global.oneUpgradeIns.downloadFileFromCloud(row.recmndVersionMsg, downloadFileFromCloudCallback, addParams);
	}

	function downloadFileFromCloudCallback(err, finish, dataLen, fileLen, addParams) {		
		if (err != null) {
			$("#table_upgrade").bootstrapTable('updateRow', {
				index: addParams.index, 
				row: {
					recmndVersion: "下载失败"
				}
			});
			
			return;
		}
		
		if (finish == true) {
			setTimeout(function() {
				var downloadDirPath = global.oneUpgradeIns.getRootDir();
				var downloadFileName = addParams.recmndVersionMsg.fileName;
				var downloadFilePath = global.nwPath.resolve(downloadDirPath, downloadFileName);		
				var downloadFileMd5 = global.jsUtil.countFileMd5(downloadFilePath);
				
				if (downloadFileMd5 == addParams.recmndVersionMsg.fileMd5) {
					$("#table_upgrade").bootstrapTable('updateRow', {
						index: addParams.index,
						row: {
							recmndVersion: "下载完成"
						}
					});
					
					for (var key in jGlobal.oneUpgrade.multiDevUpgradeVersion) {
						if ($.inArray(key, addParams.deviceNames) != -1) {
							var objectTmp = {};
							objectTmp.versionCode = addParams.recmndVersionMsg.softwareVersion;
							objectTmp.versionName = addParams.recmndVersionMsg.fileName;
							objectTmp.fileMd5 = addParams.recmndVersionMsg.fileMd5;
							jGlobal.oneUpgrade.multiDevUpgradeVersion[key] = objectTmp;
						}
					}
				} else {
					$("#table_upgrade").bootstrapTable('updateRow', {
						index: addParams.index,
						row: {
							recmndVersion: "md5校验失败"
						}
					});
				}
			}, 5000);
		}
	}
	
	function init() {
		initWindowEvent();
		initPageStatistic();
		initVariable();
		removeGlobalEvent();
		initTable();
		initEvent();
		initDom();
		resize();
		initGlobalEvent();
		
		function initWindowEvent() {
			window.operateForUpgradeTable = operateForUpgradeTable;
			window.recmndVersionShow = recmndVersionShow;
			window.operateEventsForUpgrade = {
				'click .select': function (e, value, row, index) {        
			    	importLocalVersion(row, index);
			    },
			    'click .download': function (e, value, row, index) {
			    	downloadVersionFromCloud(row, index);
			    } 
			};
			window.compareVersion = compareVersion;
		}
		function initPageStatistic() {
			statRecordEle("oneUpgrade#selectVersion");
		}
		function initVariable() {
//			upgradeTableLength = null;
			userClickRowArray = [];
		}
		function removeGlobalEvent() {
			global.devicesIns.removeAllListeners("deviceConnected");
			global.devicesIns.removeAllListeners("deviceError");
			global.devicesIns.removeAllListeners("deviceDisconnected");
			
			global.oneUpgradeIns.reg();
		}
		function initTable() {
			$('#table_upgrade').bootstrapTable({
		        data: []
		    });
			
			$(".fixed-table-body").addClass('custom-scroll');
			$("#table_upgrade").show();
			
			showUpgradeDeviceTable();
		}
		function initEvent() {
			$("#selectVersionBack").click(function() {
//				$(".main_content").load("./oneUpgrade/html/selectDevice.html");
				
				var curElement = ".main_content", nextPageUrl = "./oneUpgrade/html/oneUpgradeMenu.html";
				global.enterPageCallback(curElement, nextPageUrl);
			});
			
			$("#gotoUpgrade").click(function() {
//				$(".main_content").load("./oneUpgrade/html/upgrading.html");
				
//				console.error(userClickRowArray);
				if (userClickRowArray.length >= 1) {
					var curElement = ".main_content", nextPageUrl = "./oneUpgrade/html/upgrading.html";
					global.enterPageCallback(curElement, nextPageUrl);
				} else {
					alert(undefined, "还未确认升级版本，请确认！");
				}
			});
		}
		function initDom() {
			$('#selectVersionModal').modal({
				backdrop: 'static',
				show: false
			});
		}
		function resize() {
			var client_h = document.documentElement.clientHeight;
			var head_h = $(".main_menu").height();
			var body_h = client_h - head_h;
			
			$('#table_upgrade').bootstrapTable('resetView', {height : body_h - 55 - 65});
		}
		function initGlobalEvent() {
			global.exitPageCallback.exitFun = function () {
				removeGlobalEvent();
				return true;
			}
		}
	}
	exports.init = init;
});