
local detection = {}

local desc = '软件兼容性检测'
local cjson = require "cjson"
local GeneralFun = require ('data/rule/detection/GeneralFun')
 
function detection.Detect()
	local webip = lua_getWebIP()
	local p = GeneralFun.getClassPointer()
	GeneralFun.writeFileUTF8("== "..desc.." ==")
	
	local value = GeneralFun.getInfoBySeq(p,3004)	if value == false then return end
	local blacklist = value["blacklist"]	
	
	if string.len(blacklist) ~= 0 then
		lua_addResult(p,3)
		lua_addScore(p,-20)
		lua_addTip(p,"请卸载课程镜像中"..blacklist.."，该程序与云课堂环境不兼容")
	else
		lua_addResult(p,1)
	end
	
	lua_afterDetect(p)
end
 
return detection