
local detection = {}

local desc = '客户信息检测'
local cjson = require "cjson"
local GeneralFun = require ('data/rule/detection/GeneralFun')

function detection.Detect()
	local webip = lua_getWebIP()
	local p = GeneralFun.getClassPointer()
	GeneralFun.writeFileUTF8("== "..desc.." ==")
	
	local value = GeneralFun.getInfoBySeq(p,11)	if value == false then return end
	if string.len(value[webip]["name"]) == 0
	or string.len(value[webip]["customer_type"]) == 0
	or string.len(value[webip]["channel"]) == 0
	--or string.len(value[webip]["channel_telephone"]) == 0
	or string.len(value[webip]["maintainer"]) == 0
	or string.len(value[webip]["telephone"]) == 0
	or string.len(value[webip]["channelTele"]) == 0
	or string.len(value[webip]["classroom"]) == 0	then
		lua_addResult(p,3)
		lua_addScore(p,-2)
		lua_addTip(p,"请完整填写客户信息")
	else
		lua_addResult(p,1)
	end
	
	lua_afterDetect(p)
end
 
return detection